#include <algorithm>
#include <iostream>

using namespace std;

void pianifica(int R, int A[], int B[], int T[]) {
    // special case: 1 airplane
    if(R == 1) { T[0] = A[0]; return; }

    // init bounds (somehow, not very important)
    int min = 1;
    int max = std::min(B[1], B[R-1]) - A[0];

    // airplanes take off whenever possible
    T[0] = A[0];    // first airplane has no constraints
    while(min < max) {
        // search for solution in the middle
        int mid = (min + max + 1) / 2;
        
        bool fail = false;
        for(int i = 1; i < R; i++) {
            T[i] = std::max(T[i-1] + mid, A[i]);    // take off as soon as possible
            if(T[i] > B[i]) { fail = true; break; } // detect conflicts
        }
        
        // update bounds
        if(fail) max = mid - 1;
        else min = mid;
    }
    
    // set array T according to the value in min
    for(int i = 1; i < R; i++) T[i] = std::max(T[i-1] + min, A[i]);
}