#include <stdio.h>
#include <assert.h>

#include <algorithm>
#include <climits>
#include <vector>

#define MAXN 100000

bool lt(const std::pair<int,int>& a, const std::pair<int,int>& b) { return a.first < b.first; }

int pausa(int N, int A[], int B[]) {
    // sort intervals by arrival time
    std::vector<std::pair<int, int> > intervals;
    for(int i = 0; i < N; i++) intervals.push_back(std::make_pair(A[i], B[i]));
    std::sort(intervals.begin(), intervals.end(), lt);
    
    int res = 1;        // number of coffee
    std::vector<int> b; // tutors with coffee sorted by B
    int b_index = 0;    // index of first tutor still at the coffee machine
    b.push_back(intervals[0].second);
    for(int i = 1; i < N; i++) {
        // tutors leaving the coffee machine
        while(b_index < b.size() && b[b_index] < intervals[i].first) { b_index++; }
        
        // insert the new tutor (shift elements until find the correct position)
        b.push_back(INT_MAX);
        int j = static_cast<int>(b.size()) - 1;
        for(; j > b_index; j--) {
            if(b[j-1] <= intervals[i].second) break;
            b[j] = b[j-1];
        }
        b[j] = intervals[i].second;

        // add 1 coffee for each tutor still at the coffee machine
        res += static_cast<int>(b.size()) - b_index;
    }
    
    return res;
}


int A[MAXN], B[MAXN];

int main() {
    FILE *fr, *fw;
    int N, i;

    fr = fopen("input.txt", "r");
    fw = fopen("output.txt", "w");
    assert(1 == fscanf(fr, "%d", &N));
    for(i=0; i<N; i++)
        assert(2 == fscanf(fr, "%d %d", &A[i], &B[i]));

    fprintf(fw, "%d\n", pausa(N, A, B));
    fclose(fr);
    fclose(fw);
    return 0;
}
