#include <algorithm>
#include <iostream>

using namespace std;

long long int percorri(int N, long long int L, long long int D[], long long int P[]) {
    // init bounds
    long long min = 0;
    long long max = L;
    
    while(min < max) {
        // search solution in the middle
        long long mid = (min + max) / 2LL;

        bool fail = false;
        long long s = D[0];     // reach the first beach
        for(int i = 0; i < N; i++) {
            // go to the beach if affordable and the path to the beach is not longer than the current path
            if(s + P[i] <= mid && P[i] < s) s = P[i] + (i != N-1 ? D[i+1] : L) - D[i];
            else s += (i != N-1 ? D[i+1] : L) - D[i];
            
            // check for conflicts
            if(s > mid) { fail = true; break; }
        }
        
        if(fail) min = mid + 1; // no solutions with cost mid
        else max = mid;         // found solution with cost mid
    }
    
	return min;
}
