#include <stdio.h>
#include <assert.h>
#include <algorithm>

#define MAXN 100000
int X[MAXN], Y[MAXN], Z[MAXN];

__int128 distance[MAXN];   // distances (squared)
int N;

inline __int128 dist(__int128 x, __int128 y, __int128 z) { return x*x + y*y + z*z; }

void mappatura(int N, int X[], int Y[], int Z[]) {
    for(int i = 0; i < N; i++) distance[i] = dist(X[i], Y[i], Z[i]);
    std::sort(distance, distance+N);
}

int query(int D) {
    __int128 d = static_cast<__int128>(D) * D;  // square the distance
    // use binary search to find the reachable stars
    return (std::upper_bound(distance, distance+N, d) - distance);
}


int main() {
    FILE *fr, *fw;
    int Q, i;

    fr = fopen("input.txt", "r");
    fw = fopen("output.txt", "w");
    assert(1 == fscanf(fr, "%d", &N));
    for(i=0; i<N; i++)
        assert(3 == fscanf(fr, "%d%d%d", &X[i], &Y[i], &Z[i]));

    mappatura(N, X, Y, Z);

    assert(1 == fscanf(fr, "%d", &Q));
    for(i=0; i<Q; i++) {
        int D;
        assert(1 == fscanf(fr, "%d", &D));
        fprintf(fw, "%d\n", query(D));
    }

    fclose(fr);
    fclose(fw);
    return 0;
}