#include <stdio.h>
#include <assert.h>
#include <iostream>

using namespace std;

#define MAXN 1000000

int apri(int N, int F, int K[]) {
    // init bounds (somehow; not very important)
    int ub = K[N-1] - K[0] + 1;
    int lb = 0;
    
    while(lb < ub) {
        // search solution in the middle
        int mid = (ub + lb + 1) / 2;
        
        int last = K[0];    // always put one branch in the first city
        int count = 1;      // number of branches
        for(int i = 1; i < N; i++) {
            if(K[i] - last >= mid) { last = K[i]; count++; }    // put one branch as soon as possible
        }
        
        if(count >= F) lb = mid;    // new admissible solution of cost mid
        else ub = mid - 1;          // no admissible solutions of cost mid
    }
    
    return ub;
}


int K[MAXN];

int main() {
    FILE *fr, *fw;
    int N, F, i;

    fr = fopen("input.txt", "r");
    fw = fopen("output.txt", "w");
    assert(2 == fscanf(fr, "%d %d", &N, &F));
    for(i=0; i<N; i++)
        assert(1 == fscanf(fr, "%d", &K[i]));

    fprintf(fw, "%d\n", apri(N, F, K));
    fclose(fr);
    fclose(fw);
    return 0;
}